/*
 * Copyright LWJGL. All rights reserved.
 * License terms: https://www.lwjgl.org/license
 * MACHINE GENERATED FILE, DO NOT EDIT
 */

/**
 * Contains bindings to the <a href="http://www.openal.org/">OpenAL</a> cross-platform 3D audio API.
 * 
 * <p>LWJGL comes with a software OpenAL implementation, <a href="http://www.openal-soft.org/">OpenAL Soft</a>.</p>
 * 
 * <p>OpenAL Soft can be dynamically configured with <a href="https://github.com/kcat/openal-soft/blob/master/docs/env-vars.txt">environment variables</a>. A
 * very useful option for debugging is {@code ALSOFT_LOGLEVEL}; it can be set to values 0 through 4, with higher values producing more information.</p>
 * 
 * <p>In addition to standard OpenAL features, OpenAL Soft supports <a href="https://en.wikipedia.org/wiki/Head-related_transfer_function">HRTF</a>,
 * <a href="https://en.wikipedia.org/wiki/Ambisonics">Ambisonics</a> and <a href="http://www.codemasters.com/research/3D_sound_for_3D_games.pdf">3D7.1</a>.
 * Documentation for these features is available in the OpenAL Soft <a href="https://github.com/kcat/openal-soft/tree/master/docs">repository</a>.</p>
 */
package org.lwjgl.openal;

